﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;

namespace Com.ArHat.BLL
{
    public class B_Permit
    {
        #region 成员变量

        private DAL.D_Permit permitDAL = new DAL.D_Permit();

        #endregion

        #region 查询方法

        /// <summary>
        /// 得到所有的Action
        /// </summary>
        /// <returns></returns>
        public List<Model.M_ArHat_Action> GetAllActionList() 
        {
            List<Model.M_ArHat_Action> list = null;
            DataTable dt = permitDAL.SelectAllAction();
            if (dt != null && dt.Rows.Count > 0)
            {
                list = new List<Model.M_ArHat_Action>();
                Model.M_ArHat_Action action = null;
                foreach (DataRow row in dt.Rows)
                {
                    action = new Model.M_ArHat_Action();
                    action.AId = Convert.ToInt32(row["AId"]);
                    action.AName = row["AName"].ToString();
                    action.AValue = row["AValue"].ToString();
                    list.Add(action);
                }
            }
            return list;
        }
        /// <summary>
        /// 得到所有的Role
        /// </summary>
        /// <returns></returns>
        public List<Model.M_ArHat_Role> GetAllRoleList() 
        {
            List<Model.M_ArHat_Role> list = null;
            DataTable dt = permitDAL.SelectAllRole();
            if (dt != null && dt.Rows.Count > 0)
            {
                list = new List<Model.M_ArHat_Role>();
                Model.M_ArHat_Role role = null;
                foreach (DataRow row in dt.Rows) 
                {
                    role = new Model.M_ArHat_Role();
                    role.RId = Convert.ToInt32(row["RId"]);
                    role.RName = row["RName"].ToString();
                    list.Add(role);
                }
            }
            return list;
        }

        /// <summary>
        /// 得到Role拥有的Action
        /// </summary>
        /// <returns></returns>
        public List<int> GetRoleActionList(string rid)
        {
            List<int> list = null;
            DataTable dt = permitDAL.SelectRoleAction(rid);
            if (dt != null && dt.Rows.Count > 0)
            {
                list = new List<int>();
              
                foreach (DataRow row in dt.Rows)
                { 
                  list.Add(Convert.ToInt32(row["AId"]));
                }
            }
            return list;
        }
        #endregion

        #region 添加方法

        /// <summary>
        /// 添加一个Action
        /// </summary>
        /// <param name="action"></param>
        public void AddAction(Model.M_ArHat_Action action)
        {
            permitDAL.AddAction(action);
        }

        public void AddRole(Model.M_ArHat_Role role)
        {
            permitDAL.AddRole(role);
        }
        /// <summary>
        /// 给角色添加动作值
        /// </summary>
        /// <param name="aids"></param>
        public void AddRoleAction(string aids,string rid)
        {
            //删除该角色下的所有动作
            permitDAL.DeleteRoleAction(rid);
            //添加该角色下的动作
            foreach (string aid in aids.Split(',')) 
            {
                permitDAL.AddRoleAction(aid, rid);
            }
        }


        #endregion 
    
    
    }
}
