﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;

namespace Com.ArHat.DAL
{
    public class D_Permit
    {
        #region SQL语句

        //查询所有的动作（未分页）
        private static readonly string sql1 = "select * from ArHat_Action order by AId Desc";
        //添加一个动作
        private static readonly string sql2 = "insert into ArHat_Action values(@AName,@AValue)";
        //查询所有的角色(未分页)
        private static readonly string sql3 = "select * from ArHat_Role order by RId Desc";
        //添加一个角色
        private static readonly string sql4 = "insert into ArHat_Role values(@RName)";
        //查询角色的动作
        private static readonly string sql5 = "select a.* from ArHat_Action as a join ArHat_Role_Action as b on a.AId = b.AId where b.RId=@RId";
        //删除角色下的动作
        private static readonly string sql6 = "delete from ArHat_Role_Action where RId=@RId";
        //添加角色动作
        private static readonly string sql7 = "insert into ArHat_Role_Action values(@RId,@AId)";

        #endregion 

 

        #region 添加方法

        /// <summary>
        /// 添加一个动作
        /// </summary>
        /// <param name="action"></param>
        public void AddAction(Model.M_ArHat_Action action)
        {
            SqlParameter[] parameters = {
                                            new SqlParameter("@AName",SqlDbType.VarChar,50),
                                            new SqlParameter("@AValue",SqlDbType.VarChar,50)
                                        };
            parameters[0].Value = action.AName;
            parameters[1].Value = action.AValue;

            DAL.SqlHelper.ExecuteNonQuery(sql2, parameters);
        }


        public void AddRole(Model.M_ArHat_Role role)
        {
            SqlParameter parameter = new SqlParameter("@RName",SqlDbType.VarChar,50);
            parameter.Value = role.RName;
            DAL.SqlHelper.ExecuteNonQuery(sql4, parameter);
        }

        #endregion

        #region 查询方法

        /// <summary>
        /// 查询所有的动作
        /// </summary>
        /// <returns></returns>
        public DataTable SelectAllAction() 
        {
            return DAL.SqlHelper.ExecuteQuery(sql1);
        }
        /// <summary>
        /// 查询所有的角色
        /// </summary>
        /// <returns></returns>
        public DataTable SelectAllRole() 
        {
            return DAL.SqlHelper.ExecuteQuery(sql3);
        }
        /// <summary>
        /// 得到Role拥有的Action
        /// </summary>
        /// <param name="rid"></param>
        public DataTable SelectRoleAction(string rid)
        {
            SqlParameter parameter = new SqlParameter("@RId", SqlDbType.Int, 4);
            parameter.Value = rid;
            return DAL.SqlHelper.ExecuteQuery(sql5, parameter);
        }
        #endregion



        #region 删除方法
        public void DeleteRoleAction(string rid)
        {
            SqlParameter parameter = new SqlParameter("@RId", SqlDbType.Int, 4);
            parameter.Value = rid;
            DAL.SqlHelper.ExecuteNonQuery(sql6, parameter);
        }

        #endregion

        public void AddRoleAction(string aid, string rid)
        {
            SqlParameter[] parameters = { 
                                            new SqlParameter("@RId",SqlDbType.Int,4),
                                            new SqlParameter("@AId",SqlDbType.Int,4)
                                        };
            parameters[0].Value = rid;
            parameters[1].Value = aid;
            DAL.SqlHelper.ExecuteNonQuery(sql7, parameters);

        }
    }
}
